#include "Sincronizzatore.h"
#include "Processo.h"
#include <string>
#include <iostream>

class ProcessoSemplice : public Processo
{
 public:
  ProcessoSemplice( const string& nome, double dt ) : 
    nome_( nome ), dt_( dt ) { }
 private:
  void esegui()
  { cout << tempo() << " : processo: " << nome_ << endl; }
  double tempoProssimoEvento() const
  { return dt_; }
  const string nome_;
  const double dt_;
};

int main()
{
  Sincronizzatore s;
  ProcessoSemplice p1( "p1", 1.0 );
  ProcessoSemplice p2( "p2", 2.0 );
  ProcessoSemplice p3( "p3", 2.5 );
  s.aggiungi( &p1 );
  s.aggiungi( &p2 );
  s.aggiungi( &p3 );

  for( int i = 0; i < 20; i++ )
    s.esegui();

  return 0;
}
